// Copyright (C) 2013 File Scribe
// All Rights Reserved.
//
// Use of this code is covered by the "NUMBER DUCK API LICENSE AGREEMENT".
// Details of this agreement are found in the file "licence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.

#ifndef PICTURE_H
#define PICTURE_H
	#include "Export.h"
	#include <stdint.h>	
	
	namespace FileScribe
	{
		class Worksheet;
		class Picture
		{
			public:
				enum Format
				{
					FORMAT_PNG,
					FORMAT_JPEG, // FORMAT_JPEG_CMYK,
					FORMAT_EMF,
					FORMAT_WMF,
					FORMAT_PICT,
					FORMAT_DIB,
					FORMAT_TIFF,
				};

				FS_DLL uint16_t GetX();
				FS_DLL bool SetX(uint16_t nX);

				FS_DLL uint16_t GetY();
				FS_DLL bool SetY(uint16_t nY);

				FS_DLL uint16_t GetSubX();
				FS_DLL void SetSubX(uint16_t nSubX);

				FS_DLL uint16_t GetSubY();
				FS_DLL void SetSubY(uint16_t nSubY);

				FS_DLL uint16_t GetWidth();
				FS_DLL void SetWidth(uint16_t nWidth);

				FS_DLL uint16_t GetHeight();
				FS_DLL void SetHeight(uint16_t nHeight);

				FS_DLL const uint8_t* GetData();
				FS_DLL uint32_t GetDataSize();
				FS_DLL Format GetFormat();

			private:
				friend class Worksheet;
				friend class BiffWorksheet;
				Picture(uint8_t* pData, uint32_t nDataSize, Format eFormat, Worksheet* pWorksheet);
				virtual ~Picture();

				class Implementation;
				Implementation* m_pImplementation;
		};
	}
#endif