// Copyright (C) 2013 File Scribe
// All Rights Reserved.
//
// Use of this code is covered by the "NUMBER DUCK API LICENSE AGREEMENT".
// Details of this agreement are found in the file "licence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.

#ifndef STYLE_H
#define STYLE_H
	#include "Export.h"
	#include <stdint.h>	
	
	namespace FileScribe
	{
		class WorkbookGlobals;
		class Color;
		class Style
		{
			public:
				// Font
				FS_DLL const char* GetFont();
				FS_DLL void SetFont(const char* szFont);

				FS_DLL uint8_t GetSize();
				FS_DLL void SetSize(uint8_t nSize);

				FS_DLL const Color* GetColor();
				FS_DLL void SetColor(const Color& color);
				FS_DLL void ClearColor();
				
				FS_DLL bool GetBold();
				FS_DLL void SetBold(bool bBold);

				FS_DLL bool GetItalic();
				FS_DLL void SetItalic(bool bItalic);

				enum Underline
				{
					UNDERLINE_NONE = 0,
					UNDERLINE_SINGLE,
					UNDERLINE_DOUBLE,
					UNDERLINE_SINGLE_ACCOUNTING,
					UNDERLINE_DOUBLE_ACCOUNTING,
					NUM_UNDERLINE
				};
				FS_DLL Underline GetUnderline();
				FS_DLL void SetUnderline(Underline eUnderline);
				
				
				FS_DLL const Color* GetBackgroundColor();
				FS_DLL void SetBackgroundColor(const Color& color);
				FS_DLL void ClearBackgroundColor();

			private:
				friend class WorkbookGlobals;
				friend class BiffWorkbookGlobals;
				Style(WorkbookGlobals* pWorkbookGlobals);
				virtual ~Style();

				class Implementation;
				Implementation* m_pImplementation;
		};
	}
#endif