// Copyright (C) 2013 File Scribe
// All Rights Reserved.
//
// Use of this code is covered by the "NUMBER DUCK API LICENSE AGREEMENT".
// Details of this agreement are found in the file "licence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.

#ifndef WORKBOOK_H
#define WORKBOOK_H
	#include "Export.h"
	#include <stdint.h>
	namespace FileScribe
	{
		class CompoundFile;
		class Stream;
		class WorkbookGlobals;
		class Worksheet;
		class Style;
		class Workbook
		{
			public:
				FS_DLL Workbook(const char* szRegistrationKey);
				FS_DLL ~Workbook();

				FS_DLL void Clear();

				FS_DLL bool Load(const char * szFileName);
				FS_DLL bool Save(const char * szFileName);
				
				FS_DLL uint16_t GetNumWorksheet();
				FS_DLL Worksheet* GetWorksheetByIndex(uint16_t nIndex);
				FS_DLL Worksheet* CreateWorksheet();
				FS_DLL void PurgeWorksheet(uint16_t nIndex);

				
				FS_DLL uint16_t GetNumStyle();
				FS_DLL Style* GetStyleByIndex(uint16_t nIndex);
				FS_DLL Style* GetDefaultStyle();
				FS_DLL Style* CreateStyle();

			private:
				class Implementation;
				Implementation* m_pImpl;
		};
	}
#endif